Attribute VB_Name = "PrecisionID_ITF_Module"

'*********************************************************************
'*  Visual Basic / VBA Functions for PrecisionID V2.2
'*  Copyright, PrecisionID.com, Inc. 2005. All rights reserved.
'*
'*  You may incorporate our Source Code in your application
'*  only if you own a valid license from PrecisionID.com,
'*  for the associated font and no text is removed from the
'*  source code.
'*
'*  Distributing our source code or fonts outside your
'*  organization requires a Developer License.
'*********************************************************************

Private Text_Input As String
Private Text_Raw As String
Private End_Sequence As String
Private Start_Code As String
Private Stop_Code As String
Private Function_1 As String
Private F As Integer
Private Text_Output As String
Private Correct_Text As String
Private Printable_Text As String
Private Enc_Method As String
Private PreCheckTotal As Long
Private PreCheckVal As Integer
Private Current_Val As Long
Private Check_Val As Integer
Private Switch As Integer
Private I As Integer
Private Check_Digit As Integer
Private Current_Method As String
Private New_Line As String
Private This_Char As String
Private This_CharNum As Integer
Private Lead_Char As Integer
Private AddOn_2 As String
Private AddOn_5 As String
Private AddOn_TextFinal As String
Private HR_Text As String
Private Text_Len As Integer
'END OF DECLARACTIONS


Public Function PrecisionID_ITF(Text_Input As String) As String
     End_Sequence = "  "
     Text_Output = ""
     Text_Input = RTrim(LTrim(Text_Input))
     Correct_Text = ""
     Text_Len = Len(Text_Input)
     For I = 1 To Text_Len
          If IsNumeric(Mid(Text_Input, I, 1)) Then Correct_Text = Correct_Text & Mid(Text_Input, I, 1)
     Next I
     Text_Input = Correct_Text
     If (Len(Text_Input) Mod 2) = 1 Then Text_Input = "0" & Text_Input
     Start_Code = ChrW(203)
     Stop_Code = ChrW(204)
     Text_Len = Len(Text_Input)
     For I = 1 To Text_Len Step 2
          This_CharNum = Val((Mid(Text_Input, I, 2)))
          If This_CharNum < 94 Then Text_Output = Text_Output & ChrW(This_CharNum + 33)
          If This_CharNum > 93 Then Text_Output = Text_Output & ChrW(This_CharNum + 103)
     Next I
     PrecisionID_ITF = Start_Code & Text_Output & Stop_Code & End_Sequence
End Function


Public Function PrecisionID_MOD10(Text_Input As String) As String
' This is a general MOD10 function like the one required for EAN and UPC
     Correct_Text = ""
     Text_Len = Len(Text_Input)
     For I = 1 To Text_Len
        'Add all numbers to Correct_Text string
          If IsNumeric(Mid(Text_Input, I, 1)) Then Correct_Text = Correct_Text & Mid(Text_Input, I, 1)
     Next I
'<<<< Generate MOD 10 check digit >>>>
     Switch = 3
     PreCheckTotal = 0
     Text_Len = Len(Text_Input)
     For I = Text_Len To 1 Step -1
    'Get the value of each number starting at the end
          This_CharNum = Mid(Text_Input, I, 1)
    'multiply by the weighting Switch which is 3,1,3,1...
    'and add the sum together
          PreCheckTotal = PreCheckTotal + This_CharNum * Switch
    'change Switch for next calculation
          Switch = 4 - Switch
     Next I
'Find the Check_Digit by finding the smallest number that = a multiple of 10
     I = (PreCheckTotal Mod 10)
     If I <> 0 Then
          Check_Digit = (10 - I)
     Else
          Check_Digit = 0
     End If
     MOD10 = Str(Check_Digit)
End Function





